package libViewer;

import java.awt.*;
import java.net.*;
import java.awt.image.*;

public abstract class Book extends Canvas{

int width;
int height;
int Key;

ElementData elementdata;
Image TitleArea;

//------------------------------------------------------------------------------
// Constructs the Title Area of the Spine
//------------------------------------------------------------------------------
public void createTitleArea() {
// Image fr Text erzeugen
Image image = this.createImage(height-Settings.TEMPLATE_HEIGHT-12,30);

Graphics gr = image.getGraphics();

gr.setColor(elementdata.spine_color);
gr.fillRect(0,0,height-Settings.TEMPLATE_HEIGHT,Settings.LABEL_WIDTH);

gr.setColor(elementdata.title_color);
gr.drawString(elementdata.title,0,12);

gr.setColor(elementdata.creator_color);
gr.drawString(elementdata.creator,0,26);

ImageFilter filter = new RotateFilter(90 * (Math.PI/180.0));

ImageProducer producer = new FilteredImageSource(image.getSource(),filter);

TitleArea = this.createImage(producer);
}
//------------------------------------------------------------------------------
//  Draws Dust on the Spine
//------------------------------------------------------------------------------
public void DrawDust (int dust_level) {
   int i,j;
   Graphics g = this.getGraphics();
   g.setColor(Color.lightGray);

   if (dust_level == 1) g.drawImage(Main.dust1, 0, 0, this);
   if (dust_level == 2) g.drawImage(Main.dust2, 0, 0, this);
   if (dust_level == 3) g.drawImage(Main.dust3, 0, 0, this);
   if (dust_level == 4) g.drawImage(Main.dust4, 0, 0, this);
   if (dust_level == 5) g.drawImage(Main.dust5, 0, 0, this);

}
//------------------------------------------------------------------------------
//  Draws Fingerprints on the Spine
//------------------------------------------------------------------------------
public void DrawWellthumbed () {
    Graphics g = this.getGraphics();
    g.drawImage(Main.finger_li, 0, 30,this);
    g.drawImage(Main.finger_li, 0, 60,this);
    g.drawImage(Main.finger_li, 0, 70,this);
    g.drawImage(Main.finger_li, 0, 100,this);
    g.drawImage(Main.finger_re, width -8 , 30,this);
    g.drawImage(Main.finger_re, width -8 , 100,this);
}
//------------------------------------------------------------------------------
//  Draws Highlighting on the Spine
//------------------------------------------------------------------------------
public void DrawHighlighting (Color Spine_color) {
    int PUSHUP_VALUE  = 80;
    int PUSHUP_FACTOR = 2;
    Graphics g = this.getGraphics();
    int spine_width  = (int) elementdata.spine_width  / Main.zoom_factor;
    int spine_height = (int) elementdata.spine_height / Main.zoom_factor;
    int red   = 255;
    int green = 255;
    int blue  = 255;

    if (Spine_color.getRed() + PUSHUP_VALUE < 255)   red   = Spine_color.getRed()   + PUSHUP_VALUE;
    if (Spine_color.getGreen() + PUSHUP_VALUE < 255) green = Spine_color.getGreen() + PUSHUP_VALUE;
    if (Spine_color.getBlue() + PUSHUP_VALUE < 255)  blue  = Spine_color.getBlue()  + PUSHUP_VALUE;

    Color highlight = new Color (red, green, blue);
    g.setColor(highlight);
    g.drawLine(0, 0, 0, 300);
    g.drawLine(1, 0, 1, 300);
    if (elementdata.datatype.compareTo("hardcover") != 0) {
        g.drawLine(0, 0, 100, 0);
        g.drawLine(0, 1, 100, 1); }
    else {g.drawArc(1,-5,spine_width - 2,(int)(spine_width / Settings.BULGE_FACTOR) + Settings.BULGE_HEIGHT, 180, 180);
          g.drawArc(1,-4,spine_width - 2,(int)(spine_width / Settings.BULGE_FACTOR) + Settings.BULGE_HEIGHT, 180, 180);}
}
//------------------------------------------------------------------------------
// Event-Handler for all Elements
//------------------------------------------------------------------------------
public boolean handleEvent(Event evt) {
        switch (evt.id) {
          case Event.MOUSE_DOWN: {
               if (evt.metaDown()) {
                  URL url = null;
                  try { url = new URL(elementdata.identifier); }
                  catch (MalformedURLException e) {
                  Main.StatusWindow.appendText("INFO: URL invalid!");
                  return true;
                  }
                  // open new Blank Browser Window with the new URL
                  Main.ac.showDocument(url, url.toString());
               }
               else {
                      if (Main.Zoomfactor.getSelectedItem() == "33%") {
                      evt.id  = 1;
                      evt.key = this.Key;
                      this.postEvent(evt); }
                    }
               }
          case Event.MOUSE_ENTER: {
                Main.detail_window.title.setText(elementdata.title);
                Main.title.setText(elementdata.title);
                Main.detail_window.creator.setText(elementdata.creator);
                Main.detail_window.subject.setText(elementdata.subject);
                Main.detail_window.publisher.setText(elementdata.publisher);
                Main.detail_window.contributor.setText(elementdata.contributor);
                Main.detail_window.format.setText(elementdata.format);
                Main.detail_window.date.setText(elementdata.date);
                Main.detail_window.type.setText(elementdata.type);
                Main.detail_window.identifier.setText(elementdata.identifier);
                Main.detail_window.source.setText(elementdata.source);
                Main.detail_window.language.setText(elementdata.language);
                Main.detail_window.relation.setText(elementdata.relation);
                Main.detail_window.coverage.setText(elementdata.coverage);
                Main.detail_window.rights.setText(elementdata.rights);
                Main.detail_window.byte_size.setText(String.valueOf(elementdata.byte_size));
                Main.detail_window.page_size.setText(String.valueOf(elementdata.page_size));
                Main.detail_window.description.setText(elementdata.description);
                Main.description.setText(elementdata.description); }
        }
        return super.handleEvent(evt);
}
//------------------------------------------------------------------------------

}