package libViewer;

import java.awt.*;
import java.awt.image.*;

public class DrawAreaXY extends Panel{

  Map map;
  TextArea StatusWindow;
  int shift_x = 0;
  int shift_y = 0;
  int SHIFT_Y = 0;
  int START_Y = 0;
  int LABEL_YOFFSET    = 0;
  int MIN_SPINE_HEIGHT = 0;
  int X_STARTVALUE     = 0;
  int ulc_y = 0;
  int ulc_x = 0;
  int SHELVE_BORDER_HEIGHT = 0;
  int SHELVE_BORDER_WIDTH  = 15;
  int LABEL_OFFSET = 10;
  boolean scroll_allowed = false;

  // Settings
  int SPACE = 10;   // Space between Books

  public DrawAreaXY(Map $map, TextArea $StatusWindow) {
  map  = $map;
  StatusWindow = $StatusWindow;
  this.setLayout(null);      // very important if resizing the applet
  }
//------------------------------------------------------------------------------
public void paint (Graphics g) {

  int maxrows = 0;
  int i = 0;
  int spine_width  = 0;
  int spine_height = 0;

  if (Main.Zoomfactor.getSelectedItem() == "100%") {
      maxrows = 2;
      Main.zoom_factor = 1;
      X_STARTVALUE = 40;
      ulc_x = X_STARTVALUE;
      ulc_y = 70;
      SPACE = 10;
      LABEL_YOFFSET = 162;
      MIN_SPINE_HEIGHT = 140;
      }
  if (Main.Zoomfactor.getSelectedItem() == "33%") {
      maxrows = 5;
      Main.zoom_factor = 3;
      X_STARTVALUE = 25;
      ulc_x = X_STARTVALUE;
      ulc_y = 10;
      SPACE = 5;
      LABEL_YOFFSET = 72;
      MIN_SPINE_HEIGHT = 59;
      }

  // get max Shelve Width
  int SHELVE_WIDTH = map.getmaxShelveWidth(SPACE, Main.zoom_factor);

  // Regal zeichnen
  DrawShelve (Main.zoom_factor, g);    // sets also the SHIFT_Y Value

  if (map.y_dim < maxrows) maxrows = map.y_dim;

  if (Main.start_node_xpos > map.x_dim - 1) Main.start_node_xpos = map.x_dim - 1;
  if (Main.start_node_ypos > map.y_dim - maxrows) Main.start_node_ypos = map.y_dim - maxrows;
  if (Main.start_node_xpos == - 1) Main.start_node_xpos = 0;
  if (Main.start_node_ypos == - 1) Main.start_node_ypos = 0;
  int xpos = Main.start_node_xpos;
  int ypos = Main.start_node_ypos;
   
  // check if scrolling in Shelve is allowed
  for (i = ypos; i < maxrows + ypos; i++) {
      if (map.nodes[xpos][i].too_large) scroll_allowed = true;
      }

  int shelve_xpos = 0;
  int element_pos = 0;

  while (( ypos - Main.start_node_ypos < maxrows ) && ( ypos < map.y_dim )) {

     while (( xpos < map.x_dim ) && ( Settings.DRAWAREA_WIDTH - 30 >= ulc_x)) {

       /****** Draw Node Label ******/
       int x_value;
       x_value = ulc_x - X_STARTVALUE;
       System.out.println(x_value);

             Bullet bullet = new Bullet(map.nodes[xpos][ypos].label, map.nodes[xpos][ypos].descr);
             this.add(bullet);
             int bullet_width;
             int shelve_border;
             int shelve_border2;
              
             if (SHELVE_WIDTH <= Settings.DRAWAREA_WIDTH) {
             bullet_width = (int)((SHELVE_WIDTH + LABEL_OFFSET)* 0.75);
             shelve_border = (int)(((SHELVE_WIDTH + LABEL_OFFSET) / 8));
             shelve_border2 = (int)(((SHELVE_WIDTH + LABEL_OFFSET) * 0.75));
             }
             else { bullet_width = (int)(Settings.DRAWAREA_WIDTH * 0.75) - LABEL_OFFSET;
                    shelve_border = (int)(Settings.DRAWAREA_WIDTH / 8) - LABEL_OFFSET;
                    shelve_border2 = (int) (Settings.DRAWAREA_WIDTH * 0.75) - LABEL_OFFSET;
                    }

             bullet.createLabelArea(bullet_width, 18, map.nodes[xpos][ypos].label);

             bullet.reshape(x_value + shelve_border + LABEL_OFFSET, ulc_y + LABEL_YOFFSET,shelve_border2, 18);
             System.out.println(x_value + " " + shelve_border);

       if  ( map.nodes[xpos][ypos].empty == false ) {

        if (Main.scroll_right && scroll_allowed) {
            if (map.nodes[xpos][ypos].too_large) element_pos = map.nodes[xpos][ypos].start_element;
            else element_pos = map.nodes[xpos][ypos].number_elements;
            }

        while (( Settings.DRAWAREA_WIDTH - 30 >= ulc_x )
              && ( element_pos < map.nodes[xpos][ypos].number_elements )) {

     spine_width  = (int) map.nodes[xpos][ypos].elements[element_pos].spine_width / Main.zoom_factor;
     spine_height = (int) map.nodes[xpos][ypos].elements[element_pos].spine_height / Main.zoom_factor;

     /****** Calculate Shift-Values for dust_level ******/
     CalcShiftValues(map.nodes[xpos][ypos].elements[element_pos]);
     
     /****** Create Booktype and add Component ******/
     if (Main.not_on_repaint) {

     if (map.nodes[xpos][ypos].elements[element_pos].datatype.compareTo("hardcover") == 0) {
             hardcover book = new hardcover(map.nodes[xpos][ypos].elements[element_pos]);
             this.add(book);
             book.createTitleArea();
             book.reshape(ulc_x + shift_x, ulc_y + shift_y - (spine_height - MIN_SPINE_HEIGHT),
                          spine_width,spine_height);
             }
     if (map.nodes[xpos][ypos].elements[element_pos].datatype.compareTo("paperback") == 0) {
             paperback book = new paperback(map.nodes[xpos][ypos].elements[element_pos]);
             this.add(book);
             book.createTitleArea();
             book.reshape(ulc_x + shift_x, ulc_y + shift_y - (spine_height - MIN_SPINE_HEIGHT),
                          spine_width,spine_height);
             }
     if (map.nodes[xpos][ypos].elements[element_pos].datatype.compareTo("newspaper") == 0) {
             newspaper book = new newspaper(map.nodes[xpos][ypos].elements[element_pos]);
             this.add(book);
             //book.createTitleArea();
             book.reshape(ulc_x + shift_x, ulc_y + shift_y - (spine_height - MIN_SPINE_HEIGHT),
                          spine_width,spine_height);
             }
     if (map.nodes[xpos][ypos].elements[element_pos].datatype.compareTo("folder") == 0) {
             folder book = new folder(map.nodes[xpos][ypos].elements[element_pos]);
             this.add(book);
             book.createTitleArea();
             book.reshape(ulc_x + shift_x, ulc_y + shift_y - (spine_height - MIN_SPINE_HEIGHT),
                          spine_width,spine_height);
             }
     if (map.nodes[xpos][ypos].elements[element_pos].datatype.compareTo("standard") == 0) {
             paperback book = new paperback(map.nodes[xpos][ypos].elements[element_pos]);
             this.add(book);
             book.createTitleArea();
             book.reshape(ulc_x + shift_x, ulc_y + shift_y - (spine_height - MIN_SPINE_HEIGHT),
                          spine_width,spine_height);
             }
     if ((map.nodes[xpos][ypos].elements[element_pos].datatype.compareTo("video") == 0) ||
         (map.nodes[xpos][ypos].elements[element_pos].datatype.compareTo("sublibrary") == 0) ||
         (map.nodes[xpos][ypos].elements[element_pos].datatype.compareTo("software") == 0) ||
         (map.nodes[xpos][ypos].elements[element_pos].datatype.compareTo("other") == 0) ||
         (map.nodes[xpos][ypos].elements[element_pos].datatype.compareTo("html-doc") == 0) ||
         (map.nodes[xpos][ypos].elements[element_pos].datatype.compareTo("audio") == 0)) {
             media book = new media(map.nodes[xpos][ypos].elements[element_pos]);
             this.add(book);
             book.createTitleArea();
             book.reshape(ulc_x + shift_x, ulc_y  + shift_y - (spine_height - MIN_SPINE_HEIGHT),
                          spine_width,spine_height);
             }
     } // not on repaint end

     /****** Create side- and upper part of the Book ******/
     draw3DEffect (map.nodes[xpos][ypos].elements[element_pos], ulc_x + shift_x, ulc_y + shift_y);
     /****** Draw Convexity if Type = hardcover ******/
     if (map.nodes[xpos][ypos].elements[element_pos].datatype.compareTo("hardcover") == 0) drawConvexity (map.nodes[xpos][ypos].elements[element_pos], ulc_x + shift_x, ulc_y + shift_y);
     /****** Increase Drawing Position ******/
     ulc_x = ulc_x + spine_width + SPACE;
     shelve_xpos = shelve_xpos + spine_width + SPACE;
     element_pos++;

     } // end while

     } // end if

     if ((element_pos < map.nodes[xpos][ypos].number_elements - 1) &&
         (SHELVE_WIDTH > Settings.DRAWAREA_WIDTH)) {
         map.nodes[xpos][ypos].too_large = true;
         map.nodes[xpos][ypos].start_element = element_pos;
         }
     if (SHELVE_WIDTH <= Settings.DRAWAREA_WIDTH) {ulc_x = ulc_x + (SHELVE_WIDTH - shelve_xpos );}
     else {ulc_x = ulc_x + (Settings.DRAWAREA_WIDTH - shelve_xpos );}

     if ( Settings.DRAWAREA_WIDTH - 30 >= ulc_x) drawShelveBorder(ulc_x, ulc_y);
     ulc_x =  ulc_x + SHELVE_BORDER_WIDTH + X_STARTVALUE;
     element_pos = 0;
     shelve_xpos = 0;

     xpos++;

     }

     ypos++;
     ulc_y = ulc_y + SHIFT_Y;
     ulc_x = X_STARTVALUE;
     xpos = Main.start_node_xpos;
  }

  Main.not_on_repaint = false;
  Main.scroll_right   = false;
  
}
//------------------------------------------------------------------------------
// Service Functions Section
//------------------------------------------------------------------------------
public void draw3DEffect (ElementData elementdata, int ulc_x, int ulc_y) {
  int XOFFSET = 0;
  int YOFFSET = 0;
  int FOLDER_XOFFSET1 = 0;
  int FOLDER_XOFFSET2 = 0;

  if (Main.zoom_factor == 1) {
      XOFFSET = 23; YOFFSET = 17; FOLDER_XOFFSET1 = 17; FOLDER_XOFFSET2 = 34; }

  if (Main.zoom_factor == 3) {
      XOFFSET = 10;  YOFFSET = 7; FOLDER_XOFFSET1 = 7; FOLDER_XOFFSET2 = 14; }

  int spine_width  = (int) elementdata.spine_width  / Main.zoom_factor;
  int spine_height = (int) elementdata.spine_height / Main.zoom_factor;

  int xpos = ulc_x;
  int ypos = ulc_y - (spine_height - MIN_SPINE_HEIGHT);

  // draw upper-side
  Graphics g = this.getGraphics();
  if (Settings.DRAW_SURFACE_COLOR2) g.setColor(elementdata.surface_color2);
  else g.setColor(elementdata.surface_color);

  Polygon pol = new Polygon();
  pol.addPoint(xpos , ypos);
  pol.addPoint(xpos + spine_width, ypos);
  if (elementdata.datatype.compareTo("folder")==0) pol.addPoint(xpos + spine_width + FOLDER_XOFFSET1, ypos - YOFFSET);
  else pol.addPoint(xpos + spine_width + XOFFSET, ypos - YOFFSET);
  if (elementdata.datatype.compareTo("folder")==0) pol.addPoint(xpos + FOLDER_XOFFSET2, ypos - YOFFSET);
  else pol.addPoint(xpos + XOFFSET, ypos - YOFFSET);
  g.fillPolygon(pol);

  // draw side
  g.setColor(elementdata.surface_color);

  Polygon pol1 = new Polygon();
  pol1.addPoint(xpos + spine_width, ypos + spine_height);
  if (elementdata.datatype.compareTo("folder")==0) pol1.addPoint(xpos + spine_width + FOLDER_XOFFSET1, ypos + spine_height - YOFFSET);
  else pol1.addPoint(xpos + spine_width + XOFFSET, ypos + spine_height - YOFFSET);
  if (elementdata.datatype.compareTo("folder")==0) pol1.addPoint(xpos + spine_width + FOLDER_XOFFSET1, ypos - YOFFSET);
  else pol1.addPoint(xpos + spine_width + XOFFSET, ypos - YOFFSET);
  pol1.addPoint(xpos + spine_width, ypos);
  g.fillPolygon(pol1);

  if (elementdata.datatype.compareTo("newspaper")==0) {
     int i;
     g.setColor(Color.darkGray);
     for (i = 0; i <= spine_width; i = i + 3) {
          g.drawLine(xpos + i, ypos, xpos + i + XOFFSET, ypos - YOFFSET);
          }
  }
}
//------------------------------------------------------------------------------
public void drawConvexity(ElementData elementdata, int ulc_x, int ulc_y) {

  int spine_width  = (int) elementdata.spine_width  / Main.zoom_factor;
  int spine_height = (int) elementdata.spine_height / Main.zoom_factor;
  int xpos = ulc_x;
  int ypos = ulc_y - (spine_height - MIN_SPINE_HEIGHT);
  Graphics g = this.getGraphics();
  g.setColor(elementdata.spine_color);
  g.fillOval(xpos+1,ypos+spine_height-5,spine_width - 2,(int)(spine_width / Settings.BULGE_FACTOR) + Settings.BULGE_HEIGHT);

}
//------------------------------------------------------------------------------
public void CalcShiftValues(ElementData elementdata) {
  if (Main.zoom_factor == 1) {
    shift_x = (- 14) + (int) (elementdata.zpos.floatValue() * Float.valueOf("14").floatValue());
    shift_y = 21 - (int) (elementdata.zpos.floatValue() * Float.valueOf("21").floatValue());
  }
  if (Main.zoom_factor == 3) {
    shift_x = (- 8) + (int) (elementdata.zpos.floatValue() * Float.valueOf("8").floatValue());
    shift_y = 12 - (int) (elementdata.zpos.floatValue() * Float.valueOf("12").floatValue());
  }
}
//------------------------------------------------------------------------------
public void drawShelveBorder (int ulc_x, int ulc_y) {

  int xpos = ulc_x;
  int ypos = ulc_y;
  int ANGLE_X = 0;
  int THICKNESS = 0;
  int shift_y = 0;
  if (Main.zoom_factor == 1) { SHELVE_BORDER_HEIGHT = 250 - 15; shift_y = 70;};
  if (Main.zoom_factor == 3) { SHELVE_BORDER_HEIGHT = 100 - 15; shift_y = 10;};
  if (Main.zoom_factor == 1) { ANGLE_X = 60;THICKNESS = 45;};
  if (Main.zoom_factor == 3) { ANGLE_X = 40;THICKNESS = 30;};

  Graphics g = this.getGraphics();
  g.setColor(new Color(160,90,0));
  g.fillRect(xpos,ypos - shift_y,SHELVE_BORDER_WIDTH,SHELVE_BORDER_HEIGHT);
  g.setColor(new Color(130,70,0));
  Polygon pol = new Polygon();
  pol.addPoint(xpos + SHELVE_BORDER_WIDTH,ypos - shift_y);
  pol.addPoint(xpos + SHELVE_BORDER_WIDTH + ANGLE_X, ypos - shift_y);
  pol.addPoint(xpos + SHELVE_BORDER_WIDTH + ANGLE_X, ypos + SHELVE_BORDER_HEIGHT - THICKNESS - shift_y);
  pol.addPoint(xpos + SHELVE_BORDER_WIDTH,ypos + SHELVE_BORDER_HEIGHT - shift_y);
  g.fillPolygon(pol);

}

//------------------------------------------------------------------------------
public void DrawShelve (int zoom_factor, Graphics g) {

  int THICKNESS = 45;
  int ANGLE_X = 0;

  int y;


  if (zoom_factor == 1) { SHIFT_Y = 250; START_Y = 235; THICKNESS = 45; ANGLE_X = 60;};
  if (zoom_factor == 3) { SHIFT_Y = 100; START_Y = 85; THICKNESS = 30;  ANGLE_X = 40;};

  /* linkes Seitenteil */
  g.setColor(new Color(130,70,0));
  g.fillRect(0,0,ANGLE_X,Settings.DRAWAREA_HEIGHT);

  for (y = START_Y; y < Settings.DRAWAREA_HEIGHT; y = y + SHIFT_Y) {

  g.setColor(new Color(120,60,0));
  Polygon pol = new Polygon();
  pol.addPoint(0,y);
  pol.addPoint(ANGLE_X, y - THICKNESS);
  pol.addPoint(Settings.DRAWAREA_WIDTH,y - THICKNESS);
  pol.addPoint(Settings.DRAWAREA_WIDTH,y);
  g.fillPolygon(pol);
  g.setColor(new Color(160,90,0));
  g.fillRect(0,y,Settings.DRAWAREA_WIDTH,15);

  }
}
//------------------------------------------------------------------------------
}
