package libViewer;
//------------------------------------------------------------------------------
// Class ServerPrefs
// Author: Harald Bina
// last modified: xx.xx.1999
//------------------------------------------------------------------------------

import java.awt.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;

public class PrefsLoader {

//------------------------------------------------------------------------------
public static void readServerPrefs (TextArea StatusWindow, ActionList Actions) {


  int i;

  StatusWindow.appendText("\nLoading Server Prefs File...\n");

  if (Settings.URL) {   /****** Load from URL ******/

  InputStream data1;
  DataInputStream data2;
  try {URL fileURL = new URL(Main.DocumentBase, Settings.SERVER_PREFS_FILENAME);

    try {data1 = fileURL.openStream();
         data2 = new DataInputStream(data1);

    String line;                     // buffer for lines

    try {

    while ((line = data2.readLine()) != null) {             // until end of file - change to data2!!

    String parseit = "$";                                   // Character for Keywords
    String parm;                                            // buffer for arguments
    if (line.length() > 2) {                                // lines < 3 are useless (at least!)
      if (line.charAt(0) == parseit.charAt(0)) {            // Keyword is following
      line = line.substring(1);                             // cut Line - 1. character
      StringTokenizer st = new StringTokenizer(line);       // Separate Arguments
      if (st.countTokens() >= 2) {                          // at least 2 Tokens!

          parm = st.nextToken();                            // get Keyword
          int words = st.countTokens();

            if (parm.compareTo("SERV_URL") == 0) {          // parse Keywords sequentially
                Actions.addAction();
                Action currentAction = (Action) Actions.Items.lastElement();
                currentAction.URL = st.nextToken();
            }
            if (parm.compareTo("SERV_PORT") == 0) {          // parse Keywords sequentially
                Action currentAction = (Action) Actions.Items.lastElement();
                currentAction.Port = st.nextToken();
            }
            if (parm.compareTo("SERV_DATA") == 0) {          // parse Keywords sequentially
                Action currentAction = (Action) Actions.Items.lastElement();
                for (i = 0; i < words; i++) {
                currentAction.Data = currentAction.Data + st.nextToken();
                if (i != words - 1) currentAction.Data = currentAction.Data + " ";
                }
            }
            if (parm.compareTo("SERV_BUT1") == 0) {          // parse Keywords sequentially
                Action currentAction = (Action) Actions.Items.lastElement();
                currentAction.But1 = st.nextToken();
            }
            if (parm.compareTo("SERV_BUT2") == 0) {          // parse Keywords sequentially
                Action currentAction = (Action) Actions.Items.lastElement();
                currentAction.But2 = st.nextToken();
            }
            if (parm.compareTo("SERV_RESERVED") == 0) {          // parse Keywords sequentially
                Action currentAction = (Action) Actions.Items.lastElement();
                currentAction.Reserved = st.nextToken();

            }
            if (parm.compareTo("SERV_BUT1TXT") == 0) {          // parse Keywords sequentially
                Action currentAction = (Action) Actions.Items.lastElement();
                for (i = 0; i < words; i++) {
                currentAction.But1Txt = currentAction.But1Txt + st.nextToken();
                if (i != words - 1) currentAction.But1Txt = currentAction.But1Txt + " ";
                }

            }
            if (parm.compareTo("SERV_BUT2TXT") == 0) {          // parse Keywords sequentially
                Action currentAction = (Action) Actions.Items.lastElement();
                for (i = 0; i < words; i++) {
                currentAction.But2Txt = currentAction.But2Txt + st.nextToken();
                if (i != words - 1) currentAction.But2Txt = currentAction.But2Txt + " ";
                }

            }
            if (parm.compareTo("SERV_DESCR") == 0) {          // parse Keywords sequentially
                Action currentAction = (Action) Actions.Items.lastElement();
                for (i = 0; i < words; i++) {
                currentAction.Description = currentAction.Description + st.nextToken();
                if (i != words - 1) currentAction.Description = currentAction.Description + " ";
                }

            }


      }
      else if (Settings.ERROR_DETAILS_ON) StatusWindow.appendText("WARNING: Invalid Line detected: $" + line + "\n");
      }

    }

      }// end while
    } catch (IOException io) {StatusWindow.appendText("ERROR: I/O Error!\n");  }
    } catch (IOException io) {StatusWindow.appendText("caught IO Exception.");}
    StatusWindow.appendText("Done!\n");


  } catch (IOException io) {StatusWindow.appendText("ERROR: File not found. File: " + Settings.SERVER_PREFS_FILENAME + "\n");}
    catch (SecurityException sec) {StatusWindow.appendText(sec.getMessage());}

  } // end if

  else {

  try {RandomAccessFile file = new RandomAccessFile(Settings.SERVER_PREFS_FILENAME, "r");

    String line;                                           // buffer for lines

    try {

    while ((line = file.readLine()) != null) {             // until end of file - change to data2!!

    String parseit = "$";                                   // Character for Keywords
    String parm;                                            // buffer for arguments
    if (line.length() > 2) {                                // lines < 3 are useless (at least!)
      if (line.charAt(0) == parseit.charAt(0)) {            // Keyword is following
      line = line.substring(1);                             // cut Line - 1. character
      StringTokenizer st = new StringTokenizer(line);       // Separate Arguments
      if (st.countTokens() >= 2) {                          // at least 2 Tokens!

          parm = st.nextToken();                            // get Keyword
          int words = st.countTokens();

            if (parm.compareTo("SERV_URL") == 0) {          // parse Keywords sequentially
                Actions.addAction();
                Action currentAction = (Action) Actions.Items.lastElement();
                currentAction.URL = st.nextToken();
            }
            if (parm.compareTo("SERV_PORT") == 0) {          // parse Keywords sequentially
                Action currentAction = (Action) Actions.Items.lastElement();
                currentAction.Port = st.nextToken();
            }
            if (parm.compareTo("SERV_DATA") == 0) {          // parse Keywords sequentially
                Action currentAction = (Action) Actions.Items.lastElement();
                for (i = 0; i < words; i++) {
                currentAction.Data = currentAction.Data + st.nextToken();
                if (i != words - 1) currentAction.Data = currentAction.Data + " ";
                }
            }
            if (parm.compareTo("SERV_BUT1") == 0) {          // parse Keywords sequentially
                Action currentAction = (Action) Actions.Items.lastElement();
                currentAction.But1 = st.nextToken();
            }
            if (parm.compareTo("SERV_BUT2") == 0) {          // parse Keywords sequentially
                Action currentAction = (Action) Actions.Items.lastElement();
                currentAction.But2 = st.nextToken();
            }
            if (parm.compareTo("SERV_RESERVED") == 0) {          // parse Keywords sequentially
                Action currentAction = (Action) Actions.Items.lastElement();
                currentAction.Reserved = st.nextToken();

            }
            if (parm.compareTo("SERV_BUT1TXT") == 0) {          // parse Keywords sequentially
                Action currentAction = (Action) Actions.Items.lastElement();
                for (i = 0; i < words; i++) {
                currentAction.But1Txt = currentAction.But1Txt + st.nextToken();
                if (i != words - 1) currentAction.But1Txt = currentAction.But1Txt + " ";
                }

            }
            if (parm.compareTo("SERV_BUT2TXT") == 0) {          // parse Keywords sequentially
                Action currentAction = (Action) Actions.Items.lastElement();
                for (i = 0; i < words; i++) {
                currentAction.But2Txt = currentAction.But2Txt + st.nextToken();
                if (i != words - 1) currentAction.But2Txt = currentAction.But2Txt + " ";
                }

            }
            if (parm.compareTo("SERV_DESCR") == 0) {          // parse Keywords sequentially
                Action currentAction = (Action) Actions.Items.lastElement();
                for (i = 0; i < words; i++) {
                currentAction.Description = currentAction.Description + st.nextToken();
                if (i != words - 1) currentAction.Description = currentAction.Description + " ";
                }

            }

      }
      else if (Settings.ERROR_DETAILS_ON) StatusWindow.appendText("WARNING: Invalid Line detected: $" + line + "\n");
      }

    }

    }// end while

    } catch (IOException io) { StatusWindow.appendText("caught IO Exception."); }

    StatusWindow.appendText("Done!\n");


  } catch (IOException io) {StatusWindow.appendText("ERROR: File not found. File: " + Settings.SERVER_PREFS_FILENAME + "\n");}
    catch (SecurityException sec) {StatusWindow.appendText(sec.getMessage());}

  } // end else

}

}

